@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@using Microsoft.AspNetCore.Components.Forms
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@implements IDisposable

<Row>
  <Column>
    <Field Horizontal="true">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is4.OnDesktop">@Localize["User"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is8.OnDesktop">
        <Select TValue="string" @bind-SelectedValue="SD.Filters.UserFilter">
          <SelectItem TValue="string" Value="@("*")">(@Localize["All"])</SelectItem>
          @foreach (var user in DS.GetAllUsers(SD))
          {
            <SelectItem TValue="string" Value="@(user.EMail)">@user.GetNiceName()</SelectItem>
          }
        </Select>
      </FieldBody>
    </Field>
  </Column>
</Row>

@code {

  protected override void OnInitialized() {
    SD.Filters.FilterChanged += this.FilterChanged;
  }

  private void FilterChanged(object sender, EventArgs e) {
    this.InvokeAsync(() => this.StateHasChanged());
  }

  public void Dispose() {
    SD.Filters.FilterChanged -= this.FilterChanged;
  }
}
